#include "configdialog.h"
#include "ftpconfig.h"

#include <KLocale>
#include <QDebug>

ConfigDialog::ConfigDialog(QWidget *parent,
                           const char *name,
                           KConfigSkeleton *config) :
    KConfigDialog(parent, name, config)
{

    ConfigDialogBase *ftpConfig = new FtpConfig(this);

    addPage(ftpConfig, i18n("Upload"), "", i18n("Configure Upload"));

    setButtons(Ok | Apply | Cancel);
}

void ConfigDialog::addPage(ConfigDialogBase *page, const QString &itemName,
                           const QString &pixmapName, const QString &header, bool manage)
{
    KPageWidgetItem *item = KConfigDialog::addPage(page, itemName, pixmapName, header, manage);
    m_pageMap.insert(page->metaObject()->className(), item);
}

void ConfigDialog::show(const QString &page)
{
    if (!page.isNull()) {
        if(m_pageMap.contains(page)) {
            KConfigDialog::setCurrentPage(m_pageMap[page]);
        }
    }

    KConfigDialog::show();
    raise();
    activateWindow();
}
