#include "ftpconfig.h"
#include "ui_ftpconfig.h"

#include "settings.h"

FtpConfig::FtpConfig(QWidget *parent) :
    ConfigDialogBase(parent),
    ui(new Ui::FtpConfig)
{
    ui->setupUi(this);

    connect(ui->kcfg_Type, SIGNAL(currentIndexChanged(int)),
            this, SLOT(updateDefaultPort()));
    connect(ui->kcfg_UseClipboard, SIGNAL(stateChanged(int)),
            this, SLOT(toggleUseClipboard(int)));

    toggleUseClipboard(ui->kcfg_UseClipboard->checkState());
}

FtpConfig::~FtpConfig()
{
    delete ui;
}

void FtpConfig::updateDefaultPort()
{
    if (ui->kcfg_Type->currentIndex() == Settings::EnumType::FTP) {
        ui->kcfg_Port->setValue(21);
    } else if (ui->kcfg_Type->currentIndex() == Settings::EnumType::SFTP) {
        ui->kcfg_Port->setValue(22);
    }
}

void FtpConfig::toggleUseClipboard(const int checkBoxState)
{
    ui->clipboardGrpBox->setEnabled(checkBoxState == Qt::Checked);
}

void FtpConfig::changeEvent(QEvent *e)
{
    QWidget::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}
