#ifndef ABSTRACTGRAPHICSRECTITEM_H
#define ABSTRACTGRAPHICSRECTITEM_H

#include "kaptiongraphicsitem.h"

class AbstractGraphicsRectItem: public KaptionGraphicsItem
{
    Q_OBJECT
public:
    AbstractGraphicsRectItem(QAbstractGraphicsShapeItem *shapeItem,
                             QGraphicsItem *parent = 0);

    virtual void setShapeColor(const QColor &color);
    virtual QColor shapeColor() const;

    virtual void setShapeScale(const Scale &scale);
    virtual Scale shapeScale() const;

    virtual void createShape(const QPointF &start, const QPointF &end);
    virtual void createShape(const QPointF &start,
                             const QPointF &end,
                             const Scale &scale);

    virtual AbstractGraphicsRectItem *copy() const;

protected:
    virtual QRectF rect() const = 0;
    virtual void setRect(const QRectF &rect) = 0;

    virtual void updateRect(const QRectF &rect);
    void updateHandlesPosition();

    virtual AbstractGraphicsRectItem *getNewInstance() const = 0;

private Q_SLOTS:
    void updateTopLeft(const QPointF &newPos);
    void updateTopRight(const QPointF &newPos);
    void updateBottomLeft(const QPointF &newPos);
    void updateBottomRight(const QPointF &newPos);

private:
    HandleGraphicsItem *m_hTL;
    HandleGraphicsItem *m_hTR;
    HandleGraphicsItem *m_hBL;
    HandleGraphicsItem *m_hBR;
    QColor m_borderColor;
};

#endif // ABSTRACTGRAPHICSRECTITEM_H
