#ifndef KaptionApplication_H
#define KaptionApplication_H

#include <KUniqueApplication>
#include <QPointer>

class TrayIcon;
class Grabber;
class SnapshotPreview;

class KaptionApplication : public KUniqueApplication
{
    Q_OBJECT

public:
    KaptionApplication();
    virtual ~KaptionApplication();

public Q_SLOTS:
    void slotConfigKaption(const QString &page = QString());

private Q_SLOTS:
    void slotRegionGrabbed(const QPixmap &pixmap, const QPoint &topLeft);
    void slotQuitGrabber();
    void initObject();

private:
    void initGUI();
    void setupTrayIcon();

    TrayIcon *m_trayIcon;
    QPointer<SnapshotPreview> m_preview;
};

#endif // KaptionApplication_H
